package io.zipcoder.interfaces;

public enum Educator implements Teacher{

    NHU (200),
    KRIS (201),
    DOLIO (202),
    FRIOLAN (203);

    private final int id;
    private double hoursWorked = 0;
    private final Instructor instructor;

    Educator(int id) {
        this.id = id;
        this.instructor = new Instructor(id, this.name());
        Instructors instructors = Instructors.getInstance();
        instructors.add(instructor);
    }

    public void teach(Learner learner, double numberOfHours) {
        learner.learn(numberOfHours);
        this.hoursWorked += numberOfHours;
    }
    public void lecture(Learner[] learners, double numberOfHours) {
        double numberOfHoursPerLearner = numberOfHours / learners.length;
        for (int i = 0; i < learners.length; i++) {
            learners[i].learn(numberOfHoursPerLearner);
        }
        this.hoursWorked += numberOfHours;
    }
    public double getHoursWorked() {
        return hoursWorked;
    }
};
