package io.zipcoder.interfaces;

import java.util.ArrayList;

public abstract class People <E extends Person> {

    protected ArrayList<E> personList;

    public People() {
        personList = new ArrayList<E>();
    }

    public void add(E person) {
        personList.add(person);
    }

    public E findByID(long id) {
        E thePerson = null;
        for (E p : personList) {
            if (id == p.getId()) {
                thePerson = p;
            }
        }
        return thePerson;
    }
    public void remove(E person) {
        personList.remove(person);
    }

    public void remove(long id) {
        Person toRemove = null;
        for (Person p : personList) {
            if (id == p.getId()) {
                toRemove = p;
            }
        }
        personList.remove(toRemove);
    }
    public int getCount() {
        return personList.size();
    }

    public abstract E[] getArray();

    public void removeAll() {
        personList = new ArrayList<E>();
    }
}
