package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

import static org.junit.Assert.*;

public class InstructorTest {

    @Test
    public void testImplementation() {
        Instructor instructor = new Instructor(123456789);
        boolean actual = instructor instanceof Teacher;
        Assert.assertTrue(actual);
    }
    @Test
    public void testInheritance() {
        Instructor instructor = new Instructor(123456789);
        boolean actual = instructor instanceof Person;
        Assert.assertTrue(actual);
    }
    @Test
    public void testTeach() {
        Instructor instructor = new Instructor(123456789);
        Student student = new Student(123456789);
        instructor.teach(student, 23);

        double expected = 23;
        double actual = student.getTotalStudyTime();

        Assert.assertEquals(expected, actual, 0);

    }
    @Test
    public void testLecture() {
        Instructor instructor = new Instructor(123456789);
        Student[] students = {new Student(123456789), new Student(1234), new Student(567) };


        instructor.lecture(students, 3);

        double expected = 1;
        double actual = students[1].getTotalStudyTime();

        Assert.assertEquals(expected, actual, 0);
    }

}